\documentclass[12pt]{article}
\usepackage{graphicx}
\usepackage{epstopdf}
\usepackage{amssymb}
\usepackage{amsmath}

\def\ga{\alpha}
\def\gb{\beta}
\def\gc{\gamma}
\def\gd{\delta}
\def\ge{\epsilon}
\def\gz{\zeta}
\def\gy{\eta}
\def\th{\theta}
\def\gi{\iota}
\def\gk{\kappa}
\def\gl{\lambda}
\def\gm{\mu}
\def\gn{\nu}
\def\gx{\xi}
\def\gp{\pi}
\def\gr{\rho}
\def\gs{\sigma}
\def\gt{\tau}
\def\gu{\upsilon}
\def\ph{\phi}
\def\ch{\chi}
\def\ps{\psi}
\def\gw{\omega}

\def\gB{\Beta}
\def\gC{\Gamma}
\def\gD{\Delta}
\def\Th{\Theta}
\def\gL{\Lambda}
\def\gX{\Xi}
\def\gP{\Pi}
\def\gS{\Sigma}
\def\gU{\Upsilon}
\def\Ph{\Phi}
\def\Ps{\Psi}
\def\gW{\Omega}

\def\bA{{\bf A}}
\def\bB{{\bf B}}
\def\bC{{\bf C}}
\def\bD{{\bf D}}
\def\bE{{\bf E}}
\def\bF{{\bf F}}
\def\bG{{\bf G}}
\def\bH{{\bf H}}
\def\bI{{\bf I}}
\def\bJ{{\bf J}}
\def\bK{{\bf K}}
\def\bL{{\bf L}}
\def\bM{{\bf M}}
\def\bN{{\bf N}}
\def\bO{{\bf O}}
\def\bP{{\bf P}}
\def\bQ{{\bf Q}}
\def\bR{{\bf R}}
\def\bS{{\bf S}}
\def\bT{{\bf T}}
\def\bU{{\bf U}}
\def\bV{{\bf V}}
\def\bW{{\bf W}}
\def\bX{{\bf X}}
\def\bY{{\bf Y}}
\def\bZ{{\bf Z}}

\def\cA{{\cal A}}
\def\cB{{\cal B}}
\def\cC{{\cal C}}
\def\cD{{\cal D}}
\def\cE{{\cal E}}
\def\cF{{\cal F}}
\def\cG{{\cal G}}
\def\cH{{\cal H}}
\def\cI{{\cal I}}
\def\cJ{{\cal J}}
\def\cK{{\cal K}}
\def\cL{{\cal L}}
\def\cM{{\cal M}}
\def\cN{{\cal N}}
\def\cO{{\cal O}}
\def\cP{{\cal P}}
\def\cQ{{\cal Q}}
\def\cR{{\cal R}}
\def\cS{{\cal S}}
\def\cT{{\cal T}}
\def\cU{{\cal U}}
\def\cV{{\cal V}}
\def\cW{{\cal W}}
\def\cX{{\cal X}}
\def\cY{{\cal Y}}
\def\cZ{{\cal Z}}


\def\ba{{\bf a}}
\def\bb{{\bf b}}
\def\bc{{\bf c}}
\def\bd{{\bf d}}
\def\be{{\bf e}}
\def\bg{{\bf g}}
\def\bh{{\bf h}}
\def\bi{{\bf i}}
\def\bj{{\bf j}}
\def\bk{{\bf k}}
\def\bl{{\bf l}}
\def\bm{{\bf m}}
\def\bn{{\bf n}}
\def\bo{{\bf o}}
\def\bp{{\bf p}}
\def\bq{{\bf q}}
\def\br{{\bf r}}
\def\bs{{\bf s}}
\def\bt{{\bf t}}
\def\bu{{\bf u}}
\def\bv{{\bf v}}
\def\bw{{\bf w}}
\def\bx{{\bf x}}
\def\by{{\bf y}}
\def\bz{{\bf z}}

\def\b0{{\bf0}}
\def\o{\circ}
\def\x{\times}
\def\d{\partial}
\def\<{\langle}
\def\>{\rangle}
\def\R{{\mathbb R}}
\def\Z{{\mathbb Z}}
\def\Q{{\mathbb Q}}
\def\N{{\mathbb N}}
\def\C{{\mathbb C}}
\def\T{{\mathbb T}}
\def\Cinf{C^\infty}
\def\sb{\subseteq}
\def\sp{\superseteq}
\def\({\left(}
\def\){\right)}
\def\rank{\mbox{rank}\,}
\def\rk{\mbox{rank}\,}
\def\ddt{\frac d{dt}}
\def\corank{\mbox{corank}\,}
\def\cl{\hbox{cl}\,}
\def\im{\hbox{im}\,}
\def\Id{\hbox{Id}}
\def\Diff{\hbox{Diff}}
\def\tv{\pitchfork}
\def\ntv{\not\tv}
\def\codim{\hbox{codim}\,}
\def\tr{\hbox{tr}\,}
\def\cosec{\hbox{cosec}\,}
\def\const{\hbox{const}}
\def\lc{\lceil}
\def\rc{\rceil}
\def\lf{\lfloor}
\def\rf{\rfloor}
\def\sech{\hbox{sech}\,}
\def\csch{\hbox{csch}\,}
\def\grad{\hbox{grad}\,}
\def\nbhd{neighbourhood}
\def\dlim{\displaystyle\lim}
\def\dfrac#1#2{\displaystyle{#1\over#2}}
\def\dsum{\displaystyle\sum}
\def\dint{\displaystyle\int}
\def\diint{\displaystyle\iint}
\def\diiint{\displaystyle\iiint}
\def\doint{\displaystyle\oint}
\def\tlim{\textstyle\lim}
\def\tfrac#1#2{\textstyle{#1\over#2}}
\def\tsum{\textstyle\sum}
\def\tint{\textstyle\int}
\def\del{\nabla}
\def\div{\hbox{div}\,}
\def\curl{\hbox{curl}\,}
\def\intL{\int\limits}
\def\iintL{\iint\limits}
\def\iiintL{\iiint\limits}

\def\abs{\hbox{abs}\,}
\def\sgn{\hbox{sgn}\,}
\def\dom{\hbox{dom}\,}


\def\eval{\,\Bigl.\Bigl|}



\def\drawbox#1{\lower6pt\hbox{{\vbox{\hrule\hbox{\vrule\kern15pt
   \vbox{\kern10pt\vbox{\hbox{#1}}\kern10pt} 
   \kern18pt\vrule}\hrule}}}}

\def\picture #1 by #2 (#3){
  \medbreak
		$$\vbox to #2{
    \hrule width #1 height 0pt depth 0pt
    \vfill
    \special{picture #3}
  }$$
}

\def\scaledpicture #1 by #2 (#3 scaled #4){
  \dimen0=#1 
		\dimen1=#2
  \divide\dimen0 by 1000 
   \multiply\dimen0 by #4
  \divide\dimen1 by 1000 
   \multiply\dimen1 by #4
  \picture \dimen0 by \dimen1 (#3 scaled #4)}
%\input mypars
%The following are plain tex style parameters 

\baselineskip=12pt
\hoffset=0pt
\voffset=0 cm
\leftskip=0pt
\rightskip=0pt
\parindent=0cm

%And these are latex style parameters

\headsep=0cm
\headheight=0cm
\evensidemargin=0cm
\oddsidemargin=0cm
\parskip=12pt
\textwidth=16.5 true cm
\textheight=22 true cm
\topmargin=1cm

\def\Gr{Gr\"obner}
\def\kn{k[x_1,\dots,x_n]}
\def\lc{\mbox{\sc lc}}
\def\lt{\mbox{\sc lt}}
\def\lp{\mbox{\sc lp}}
\def\gcd{\mbox{\sc gcd}}
\def\lcm{\mbox{\sc lcm}}
\def\red#1{\stackrel{#1}{\longrightarrow}}
\def\redplus#1{\stackrel{#1}{\longrightarrow}_+}

\newtheorem{theorem}{Theorem}[section]
\newtheorem{lemma}{Lemma}[section]
\newtheorem{definition}{Definition}[section]
\newtheorem{example}{Example}[section]
\newtheorem{corollary}{Corollary}[section]

\newenvironment{proof}
{\begin{trivlist}
\item[\hskip \labelsep {\bf Proof.}]
}
{\hfill$\Box$
\end{trivlist}}
           

\def\pagenumbers{\headline={\iftitle\hfil\global\titlefalse                     
   \else\hss\rm\folio\hss\fi}}                                                  
\newtoks\option                                                                 
\newtoks\solnhead                                                               
\newtoks\sheetname                                                              
\option={,}                                                                     
\def\separate#1,#2@{\def\optionid{#1}\def\optionname{#2}}                      
\def\fullwidth{\everypar{}\parindent=0pt\relax}                                 

\def\maketitle{
\begin{center}
{\sc Victoria University of Wellington\\
School of Mathematics, Statistics and Operations Research}\\
\smallskip
{\sl
Te Kura M{\=a}tai Tatauranga, Rangahau P{\=u}naha}
\end{center}
\expandafter\separate\the\option@
\hbox to\hsize{\hrulefill}
\nointerlineskip
\vskip3pt                                  
\hbox
to\hsize{\strut\rlap{\optionid}\hfill{\sc\optionname}\hfill\llap{\number\year}}          
\nointerlineskip
\vskip2pt
\hbox to\hsize{\hrulefill}}

\let\filbreak=\relax                                                           
\def\head{\filbreak\vskip 18pt\fullwidth                                    
   \def\filbreak{\global\let\filbreak=\fillbreak}%                            
   \centerline{\large\bf \the\sheetname}\nobreak
   \vskip 12pt minus 3pt}                                                       
\def\tutorial{\sheetname={Tutorial}\head}                                      
\def\assignment{\sheetname={Assignment}\head}                                  
\def\sheet#1{\sheetname={#1}\head}                                             
\def\showdue#1{\hbox to\hsize{\hfil Due: #1}
\vskip 5pt minus 3pt}

\leftmargin=0pt              

\begin{document}

\option={MATH 437,Gr\"obner Bases and Their Applications}        
\maketitle
\medskip 
\setcounter{section}6
\section{\Gr Bases}

\subsection{Characterising \Gr~bases}



\begin{definition}
Given a non-zero ideal $I\subseteq\kn$ and a term order on $\T^n$, a set
$G=\{g_1,\dots,g_s\}\subseteq I$ is a {\bf {\Gr} basis} for $I$ if for all $f\in I$
there exists $g_i\in G$ such that
$\lp(g_i)|\lp(f)$.
\end{definition}

We seek to answer the following:
\begin{itemize}
\item
does a {\Gr} basis guarantee reduction to $0$ for any element in the ideal?
\item
is the {\Gr} basis actually a basis for $I$?
\item
does every ideal actually have a {\Gr} basis for any given term order?
\item
to what extent is a {\Gr} basis unique and how does this depend on the term order
used in the division algorithm?
\end{itemize}


We start by establishing a number of characterisations of {\Gr} bases which will
enable us to answer the existence question affirmatively. An important construction
is the following: for any set $S\subseteq\kn$, the {\bf leading term ideal} is 
\[
\lt(S)=\<\lt(f)\,:\,f\in S\>.
\]

\begin{theorem}
\label{grobchar}
Given a non-zero ideal $I\subseteq\kn$, the following are equivalent:
\begin{enumerate}
\item
$G\subseteq I$ is a {\Gr} basis;
\item
$f\in I$ if and only if $f\stackrel{G}{\longrightarrow}_+0$;
\item
$f\in I$ if and only if $f=\dsum_{i=1}^sh_ig_i$ with
$\lp(f)=\max\{\lp(h_i)\lp(g_i)\,:\,i=1,\dots,s\}$
\item
$\lt(G)=\lt(I)$
\end{enumerate}
\end{theorem}

\begin{proof}

$(1)\Rightarrow(2)$.  
Suppose $f\in\kn$ and $f\stackrel{G}{\longrightarrow}_+r$. If
$r=0$ then we have $f=\sum u_ig_i$ and since $g_i\in I$ for all $i$, $f\in I$.
(This establishes $\Leftarrow$ in (2), but that is always true and doesn't require
that $G$ be a {\Gr} basis.)

On the other hand, if $f\in I$ but $r\neq0$, then $r=f-\sum u_ig_i\in I$. Since $r$
is assumed reduced, $\lp(g_i)\nmid\lp(r)$ for all $i$, but this contradicts the
assumption that $G$ is a {\Gr} basis.

$(2)\Rightarrow(3)$. This is a consequence of the Division Algorithm.

$(3)\Rightarrow(4)$. 
Clearly $\lt(G)\subseteq\lt(I)$. For the converse,  it is enough to show that for all $f\in I$, $\lt(f)\in\lt(G)$ (why?) By (3), $f=\sum
h_ig_i$ and there is no cancellation among terms of higher order than $\lt(f)$ so
$\lt(f)=\sum_{j}\lt(h_j)\lt(g_j)$ where the sum is over those $j$ for which
$\lp(h_j)\lp(g_j)=\lp(f)$. Thus $\lt(f)\in\lt(G)$ and so
$\lt(I)\subseteq\lt(G)$.

$(4)\Rightarrow(1)$. Exercise.
\end{proof}

\begin{corollary}
If $G=\{g_1,\dots,g_s\}$ is a {\Gr} basis for $I$ then $I=\<g_1,\dots,g_s\>$.
\end{corollary}

\begin{corollary}
Let $G$ be a {\Gr} basis and $f\in\kn$. If $f\redplus{G}r$ then $r$ is unique.
\end{corollary}

\begin{theorem}[Existence of {\Gr} Bases] 
Every non-zero ideal $I\subseteq\kn$ has
a {\Gr} bases with respect to any term order.
\end{theorem}

\begin{proof}
We use Theorem~\ref{grobchar} (4).  By the Hilbert Basis Theorem, $\lt(I)=\<h_1,\dots,h_t\>$ for some $h_i\in\lt(I)$.
In fact for each $i$,
\[
h_i=\sum_{j=1}^{s_i}u_{ij}\gt_{ij}
\]
where $\gt_{ij}=\lt(g_{ij})$ for some $g_{ij}\in I$. Let 
\[
G=\{g_{ij}\,:\,1\leq i\leq t, 1\leq j\leq s_i\}.
\]
Then for any $\phi\in\lt(I)$, 
\[
\phi=\sum_{i}v_{i}h_i=\sum_{i,j}v_iu_{ij}\gt_{ij}\in\lt(G).
\]
By Theorem~\ref{grobchar} (4), $G$ is a {\Gr} basis for $I$.
\end{proof}

This is very reassuring. However the proof is based on the non-constructive Hilbert
Basis Theorem.  What we would like ideally is an algorithm, akin to the Euclidean
Algorithm, that, given a finite basis for an ideal, would output a {\Gr} basis.
This was the significant contribution of Bruno Buchberger, who named these bases
for his research supervisor, Wolfgang {\Gr}.

\subsection{S--polynomials}


In the one-variable case, we discovered that there is a unique monic generator for
any ideal, and that given a basis, that unique generator is the {\gcd} of the given
generators. This has the property that its leading term is least among members of
the ideal (with respect to the unique term order $1<x<x^2<\dots$). Hence, given
some other set of generators, the problem must be that they contain higher order
leading terms which, by suitable combination can be made to cancel.  

This is
precisely the problem in the multivariate case too. Suppose $I=\<f_1,\dots,f_s\>$.
The generators fail to form a {\Gr} basis if there is some $f\in I$ such that
$\lp(f_i)\nmid\lp(f)$ for all $i$.  On the other hand, since $f$ is in the ideal,
we have $f=\sum_{i=1}^s h_if_i$ meaning that there must be some cancellation among
the $\lp(h_if_i)=\lp(h_i)\lp(f_i)$ terms. 

The simplest possible way to construct such a combination out of 2 polynomials is
by a simple sort of cross-multiplication. Recall that for any two
non-zero polynomials
$f,g$ the {\bf least common multiple} (\lcm) is the unique monic polynomial $h$ such
that $f,g$ divide $h$ and if $f,g$ also divide $h'$ then $h$ divides $h'$.

\begin{definition}
Let $f_1,f_2\in\kn$ (with a given term order) be non-zero polynomials and set
$l=\lcm(\lp(f_1),\lp(f_2))$. The {\bf S--polynomial} of $f_1$ and $f_2$ is:
\[
S(f_1,f_2)=\frac{l}{\lt(f_1)}f_1-\frac{l}{\lt(f_2)}f_2.
\]
\end{definition}

{\bf Example.} Suppose $f_1=2xy-x$, $f_2=3x^2-y$ in $\Q[x,y]$ with {\sc deglex} and
$x>y$.  

Then $l=\lcm(xy,x^2)=x^2y$.  Now
\begin{eqnarray*}
S(f_1,f_2)&=&\frac{x^2y}{2xy}(2xy-x)-\frac{x^2y}{3x^2}(3x^2-y)\\
&=&x^2y-\tfrac12x^2-x^2y+\tfrac13y^2=-\tfrac12x^2+\tfrac13y^2.
\end{eqnarray*}
Note that, of course, $S(f_1,f_2)\in\<f_1,f_2\>$. However if we reduce the S--polynomial via $\{f_1,f_2\}$ we get $\frac13y^2+\frac16y$ which is non-zero.  We can deduce from the Characterisation Theorem that $\{f_1,f_2\}$ is not a \Gr~basis.


In general we may be faced with the situation where $f=\sum_{i=1}^s h_if_i$ and
several of the leading terms of summands with a common leading power 
cancel. Of course, this happens because the {\it leading
coefficients} cancel. So it is sufficient to consider simply scalar (rather than
polynomial) combinations of $f_i$. The following Theorem shows that we can reduce
all cases of leading term cancellation to consideration of S--polynomials.


\begin{theorem}
\label{spoly}
Suppose $f_1,\dots,f_s\in\kn$ and for all $i=1,\dots,s$,  $\lp(f_i)=X\neq0$.
If $f=\dsum_{i=1}^sc_if_i$, where $c_i\in k$, and $\lp(f)<X$ then
\[
f=\sum_{1\leq i<j\leq s}d_{ij}S(f_i,f_j)
\]
and, moreover, $\lp(S(f_i,f_j))<X$ for all $1\leq i<j\leq s$.
\end{theorem}


\begin{proof}
Suppose $f_i=a_iX+\mbox{lower order terms}$, $a_i\neq0$, then $\sum c_ia_i=0$. Now,
since
$\lp(f_i)=\lp(f_j)$ for any $i\neq j$, 
\[
S(f_i,f_j)=\frac1{a_i}f_i-\frac1{a_j}f_j
\]
and the leading coefficients in each term are~1. Since the leading power in each is
$X$, the leading terms cancel and  $\lp(S(f_i,f_j))<X$.

Also we have:
\begin{eqnarray*}
f&=&c_1f_1+\dots+c_sf_s\\
&=&c_1a_1\left(\frac1{a_1}f_1\right)+\dots+c_sa_s\left(\frac1{a_s}f_s\right)\\
&=&c_1a_1\left(\frac1{a_1}f_1-\frac1{a_2}f_2\right)+(c_1a_1+c_2a_2)
\left(\frac1{a_2}f_2\right)+\dots+c_sa_s\left(\frac1{a_s}f_s\right)\\
&=&c_1a_1\left(\frac1{a_1}f_1-\frac1{a_2}f_2\right)+(c_1a_1+c_2a_2)
\left(\frac1{a_2}f_2-\frac1{a_3}f_3\right)+\\
&&\qquad+(c_1a_1+c_2a_2+c_3a_3)
\frac1{a_3}f_3+\dots+c_sa_s\left(\frac1{a_s}f_s\right)\\
&=&c_1a_1\left(\frac1{a_1}f_1-\frac1{a_2}f_2\right)+(c_1a_1+c_2a_2)
+\dots\\
&&\qquad+(c_1a_1+\dots+c_{s-1}a_{s-1})
\left(\frac1{a_{s-1}}f_{s-1}-\frac1{a_s}f_s\right)+
\left(\sum_{i=1}^s c_ia_i\right)\frac1{a_s}f_s\\
&=&d_{12}S(f_1,f_2)+\dots d_{s-1,s}S(f_{s-1},f_s)\qquad\mbox{(as $\sum c_ia_i=0$)}
\end{eqnarray*}
as required. 
\end{proof}

\subsection{Buchberger's Algorithm}

{\Gr} bases were introduced to ensure that the multivariate Division Algorithm
could always proceed when we thought it should be able to.  We then showed that,
equivalently, ideal membership could always be established by reduction to zero if
the reducing set of polynomials form a {\Gr} basis, and that, hence, remainders
are unique. Finally,  $G=\{g_1,\dots,g_s\}$ is {\Gr} basis for $I$ if and
only if the leading term ideal of $G$ coincides with that of $I$. A consequence of
this and the Hilbert Basis Theorem is the existence of a {\Gr} basis for any
non-trivial ideal.  The downside was that, because HBT is non-constructive, we
can't use the proof of existence constructively.



Recall the example from Lecture~6: $f=x^2y-y\in\Q[x,y]$ (using {\sc deglex} with
$y<x$) and $G=\{g_1=x^2-y,g_2=xy-x\}$. We showed that, while $f$ is in the ideal
generated by $g_1,g_2$ nevertheless,
$f\redplus{G} y^2-y$ so $G$ was not a {\Gr} basis. It is $S(g_1,g_2)$ that is the
impediment to reduction:
\[
S(g_1,g_2)=yg_1-xg_2=y^2-x^2
\]
and $S\redplus{G}y^2+y\neq0$.

\begin{theorem}[Buchberger's Theorem]
\hfill

$G=\{g_1,\dots,g_t\}$ is a {\Gr} basis for $I=\<g_1,\dots,g_t\>$ if and only
if for all $i\neq j$
\[
S(g_i,g_j)\redplus{G}0.
\]
\end{theorem}

\begin{proof}
The forward implication follows immediately from the characterisation
theorem, part~(2), because $S(g_i,g_j)$ is in $\<G\>$.

For the converse we use part~(3) of the theorem that says $G$ is a {\Gr} basis if
and only if every element of the ideal can be expressed as a combination of $g_i$s
without higher order cancellation. The proof is by contradiction.  So suppose $G$ is {\em not} a {\Gr} basis. Then, by Theorem~\ref{grobchar}(3), there
exists $f\in I$ such that whenever $f=\dsum_{i=1}^t h_ig_i$ we have $\max\{\lp(h_i)\lp(g_i)\,:\,1\leq
i\leq t\}>\lp(f)$. By well ordering, among all such representations of $f$ there must be a least such
maximum term, say $X$, and we still have $X>\lp(f)$. 

Consider the corresponding sum $\dsum_{i=1}^t h_ig_i$ and define the subset
$\gs=\{i\,:\,\lp(h_i)\lp(g_i)=X\}$---we are only interested in these cancelling
leading terms. Let $h_i=c_iX_i+\mbox{lower order terms}$ for each $i\in\gs$,
where $c_i\in k$ and $X_i=\lp(h_i)$ and set:
\[
g=\sum_{i\in\gs}c_iX_ig_i.
\]
The construction ensures that $f$ and $g$ differ by terms of order less than $X$. 
The role of $g$ is to focus on the essential part of $f$. So, while
$\lp(X_ig_i)=\lp(h_ig_i)=X$ for each $i$, we also have $\lp(g)=\lp(f)<X$. Thus $g$
satisfies the hypotheses of Theorem~\ref{spoly} and so
\[
g=\sum_{i<j\in\gs}d_{ij}S(X_ig_i,X_jg_j)
\]
where $d_{ij}\in k$ and $\lp(S(X_ig_i,X_jg_j))<X$. 

By choice of $\gs$,
$\lcm(\lp(X_ig_i),\lp(X_jg_j))=X$ so
\begin{eqnarray*}
S(X_ig_i,X_jg_j)&=&\frac{X}{\lt(X_ig_i)}X_ig_i-\frac{X}{\lt(X_jg_j)}X_jg_j\\
&=&\frac{X}{\lt(g_i)}g_i-\frac{X}{\lt(g_j)}g_j\\
&=&\frac{X}{X_{ij}}S(g_i,g_j)
\end{eqnarray*}
where $X_{ij}=\lcm(\lp(g_i),\lp(g_j))$.
By hypothesis, $S(g_i,g_j)\redplus{G}0$ and hence we also have
$S(X_ig_i,X_jg_j)\redplus{G}0$ whence, for each pair $(i,j)$, 
$S(X_ig_i,X_jg_j)=\sum_{k=1}^th_{ijk}g_k$, satisfying
\[
\max_{1\leq k\leq s}(\lp(h_{ijk})\lp(g_k))=\lp(S(X_ig_i,X_jg_j)<X.
\]

Thus, recalling that $f$ and $g$ differ by terms of order $<X$,
\[
f=\sum_{i<j\in\gs}d_{ij}\left(\sum_{k=1}^th_{ijk}g_k
\right)+(\mbox{terms of order $<X$})
\]
which gives a sum expression for $f$ in which all terms are of order
$<X$, contradicting the assumption that
$X$ is minimal among such orders.
\end{proof}


\end{document}


\subsection{Buchberger's Algorithm}

Buchberger's Theorem shows us that the obstruction to a given set, $G$, being a
{\Gr} basis is the irreducibility of some S--polynomial for a pair of elements of
the set. This provides a strategy for generating a {\Gr} basis from the given set of
generators for an ideal as follows:
\begin{itemize}
\item
calculate all S--polynomials
\item
reduce each via $G$ and add any non-zero remainders to $G$
\item
repeat until all S--polynomials reduce.
\end{itemize}

\fbox{\bf Buchberger's Algorithm}
\begin{itemize}
\item
{\bf INPUT:} $F=\{f_1,\dots,f_s\}\subseteq\kn$, $f_i\neq0$ for all $i$.
\item
{\bf INITIAL VALUES:} $G:=F$, $\cG=\{\,\{f_i,f_j\}\,:\,f_i\neq f_j\in G\}$.
\item
{\bf ALGORITHM: While $\cG\neq\emptyset$ do}
\begin{itemize}
\item
choose $\{f,g\}\in\cG$
\item
$\cG:=\cG-\{\{f,g\}\}$
\item
$S(f,g)\redplus{G}h$
\item
{\bf IF} $h\neq0$, {\bf THEN}
\begin{eqnarray*}
\cG&:=&\cG\cup\{\,\{u,h\}\,:\,u\in G\}\\
G&:=&G\cup\{h\}
\end{eqnarray*}
\end{itemize}
{\bf OUTPUT:} $G$, a {\Gr} basis for $\<F\>$.
\end{itemize}

There are two key things that need to be proved before we can accept this algorithm:
\begin{enumerate}
\item
does the algorithm terminate?
\item
is $G$ a {\Gr} basis?
\end{enumerate}

{\bf Proof of (1).}  In the algorithm we generate a chain of sets
\[
G_1\subset G_2\subset \dots
\]
where $G_{i+1}=G_i\cup\{h_i\}$ and $h_i$ is reduced with respect to $G_i$. It
follows that $\lt(h_i)\notin\lt(G_i)$ and hence we have an ascending chain of
ideals:
\[
\lt(G_1)\subseteq\lt(G_2)\subseteq\dots
\]
By the ACC this chain must terminate.

{\bf Proof of (2).} If $G$ is the terminating set then $S(g_i,g_j)\redplus{G}0$ and
by Buchberger's Theorem, $G$ is a {\Gr} basis.

{\bf Example.} Find a {\Gr} basis for the ideal generated by $f_1=y^2+yx+x^2$,
$f_2=y+x$, $f_3=y$ in $\Q[x,y]$ with respect to {\sc lex} ordering with $y>x$.

\fbox{Step 0}
\begin{eqnarray*}
\\[-1.5cm]
G&:=&\{y^2+yx+x^2, y+x, y\}\\
\cG&:=&\{\{f_1,f_2\},\{f_1,f_3\},\{f_2,f_3\}\}
\end{eqnarray*}

\fbox{Step 1}
\\[-1cm]
\begin{itemize}
\item
Choose $\{f_1,f_2\}\in\cG$. 
\item
$S(f_1,f_2)=\frac{y^2}{y^2}(y^2+yx+x^2)-\frac{y^2}{y}(y+x)=x^2$. Since $\lt(f_i)$
does not divide $\lt(x^2)$ for any $i=1,2,3$, $h=x^2$ is reduced modulo $G$.
\end{itemize}
\begin{eqnarray*}
\\[-1.5cm]
G&:=&\{y^2+yx+x^2, y+x, y,x^2\}\\
\cG&:=&\{\{f_1,f_3\},\{f_2,f_3\},\{f_1,f_4\},\{f_2,f_4\},\{f_3,f_4\}\}
\end{eqnarray*}
where $f_4=x^2$.

\fbox{Step 2}
\\[-1cm]
\begin{itemize}
\item
Choose $\{f_1,f_3\}\in\cG$. 
\item
$S(f_1,f_3)=\frac{y^2}{y^2}(y^2+yx+x^2)-\frac{y^2}{y}(y)=yx+x^2$. Now
$yx+x^2\red{f_2}0$.
\end{itemize}
\begin{eqnarray*}
\\[-1.5cm]
G&:=&\{y^2+yx+x^2, y+x, y,x^2\}\\
\cG&:=&\{\{f_2,f_3\},\{f_1,f_4\},\{f_2,f_4\},\{f_3,f_4\}\}
\end{eqnarray*}


\fbox{Step 3}
\\[-1cm]
\begin{itemize}
\item
Choose $\{f_2,f_3\}\in\cG$. 
\item
$S(f_2,f_3)=\frac{y}{y}(y+x)-\frac{y}{y}(y)=x$ which is reduced $\mod G$.
\end{itemize}
\begin{eqnarray*}
\\[-1.5cm]
G&:=&\{y^2+yx+x^2, y+x, y,x^2,x\}\\
\cG&:=&\{\{f_1,f_4\},\{f_2,f_4\},\{f_3,f_4\},\{f_1,f_5\},\{f_2,f_5\},\{f_3,f_5\},
\{f_4,f_5\}\}
\end{eqnarray*}

\fbox{Step 4\dots}
\newline
Since now $x$ and $y$ are in $G$, it is fairly clear that $S(f_i,f_j)\redplus{G}0$
for all $(f_i,f_j)\in\cG$. The algorithm terminates. A {\Gr} basis for the ideal is
\[
G=\{y^2+yx+x^2, y+x, y,x^2,x\}.
\]


\end{document}
